/*****************************************************************************
    globals.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2005 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include <grp.h>
#include <setjmp.h>

#include "mf.h"
#include "params.h"
#include "dllapps.h"
#include "version.h"
#include "getarg.h"

#ifdef	GLOBDEF
#define	EXTRN
#define	INIT(A)	= A ;
#else
#define	EXTRN	extern
#define	INIT(A)	;
#endif	/* GLOBDEF */

/*
	General TFTP globals
*/

#define SD_PERMIT	0	/* send error packets		 	*/
#define SD_DENY	 	1	/* silently deny (no error packets) 	*/
#define SD_KEEP	 	2	/* keep settings of silentDeny		*/
#define SD_UNSET 	4	/* error msg flag settings not altered	*/
#define SD_OLDPROTO	8	/* use old (RFC 1350) protocol		*/ 

#define NO_FILTER       0	/* no i/o filter in use			*/
#define FILTER_RUNNING  1	/* i/o filter started & running		*/
#define FILTER_DONE     2	/* i/o filter exited or killed		*/

#define DEFTIMER     {{DEFSENDTMO,0},{DEFRECVTMO,0},\
                      {DEFSACKTMO,0},{DEFRACKTMO,0},\
                      {DEFIDLETMO,0},{DEFCONNTMO,0},\
                      {0,0},{0,0},MAXRETRIES,SD_UNSET,0.0}

#define globCheckCmd(G) globCheck(__FUNCTION__,__LINE__,&MF_##G,#G,MF_CMD)
#define globCheckCfg(G) globCheck(__FUNCTION__,__LINE__,&MF_##G,#G,MF_CONFIG)
#define globCheckRun(G) globCheck(__FUNCTION__,__LINE__,&MF_##G,#G,MF_RUN)

#define globCmd(G,V) if(!globCheckCmd(G)){G=V;}
#define globCfg(G,V) if(!globCheckCfg(G)){G=V;}
#define globRun(G,V) if(!globCheckRun(G)){G=V;}

#include "glauto.h"

#endif /* GLOBALS_H */
